Subject: bug#59802: 30.0.50; Checkbox button not rendered

From: Eli Zaretskii <[email-masked]>
Date: Sat, 10 Dec 2022 19:04:17 +0200

> From: Stephen Berman <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Sat, 10 Dec 2022 17:24:14 +0100
> 
> On Sat, 10 Dec 2022 15:49:21 +0200 Eli Zaretskii <[email-masked]> wrote:
> 
> >> From: Stephen Berman <[email-masked]>
> >> Cc: Manuel Giraud <[email-masked]>,  [email-masked]
> >> Date: Fri, 09 Dec 2022 14:41:27 +0100
> >>
> >> > What happens if you manually create a buffer with the checkbox and
> >> > text following it -- does the problem happen in that case as well?
> >>
> >> It does for me: the attached image shows four buffers containing the
> >> checkbox.svg and checkbox.xpm images from /etc/images.  The leftmost
> >> buffer shows the default font size, the other buffers show increases of
> >> the font size successively by two steps with `C-x C-+'.
> >>
> >> (The rightmost buffer shows another oddity: the line number is
> >> supposedly 47.  This number appears when the cursor moves from 'T' to
> >> 'e'.  This also happens in the other buffers, but only those with
> >> increased font size show line number 47; in the leftmost buffer, it
> >> shows line number 27.)
> >
> > I couldn't reproduce any of this.  But since you didn't say how you
> > created that display, exactly, it's possible that I tried something
> > different.
> >
> > Can you show the Lisp which you used?
> 
> I create buffer "a" by typing this (with emacs -Q):
> 
> C-x b a
> M-: (insert-image-file "path/to/emacs/etc/images/checked.svg")
> C-f
> M-: (insert-image-file "path/to/emacs/etc/images/checked.xpm")
> C-f
> Test
> 
> To create buffer "+2" I type `C-x h M-w' in buffer "a", and then type
> `C-x b +2 C-y'.  However, this results in only the image checked.svg
> being displayed in "+2", but with point not before but after the image,
> so then I insert the image checked.xpm and the string "Test" as above.
> Then I typed `C-x C-+' twice.  I create buffers "+4" and "+6" likewise
> (typing `C-x C-+' four and six times, respectively).
> 
> Concerning the line number display, after inserting checked.svg in
> buffer "a" and typing `C-f' the mode line displays "L1".  After
> inserting checked.xpm as above, the mode line displays "L7", and after
> typing `C-f T' it displays "L27" and remains like that while and after
> typing "est".  After typing `C-y' in buffer "+2" (which displays only
> checked.svg), the mode line displays "L27" and stays like that after
> inserting checked.xpm and typing `C-f'.  But as soon as I type "T" the
> mode line displays "L47".  (So I was mistaken in saying the line number
> display changes by changing the font size.)

We are still discussing the problem with misalignment of images, are
we?  Because most of what you describe is unrelated to that.  (If
those other aspects bother you or surprise you, we can talk about that
as well.)

As for the misalignment, I'm guessing that your librsvg is newer than
mine, so it supports scaling the SVG images as you scale text.  My
librsvg doesn't support that, and so the SVG image remains aligned
with the XPM one, slightly lower than the baseline of the text (which
could probably controlled by the :ascent property of the image, if
that is a problem).

Manuel, if this is what you see, then try playing with :ascent.  E.g.,
did you try to use ":ascent 'center"?